






















# makeflow_ec2_estimate(1)

## NAME
**makeflow_ec2_estimate** - estimate Amazon services cost and time for running Makeflow

## SYNOPSIS
****makeflow_ec2_estimate <makefile>****

## DESCRIPTION

Before using **makeflow_ec2_estimate**, make sure that you install the AWS Command
Line Interface tools, have the **aws** command in your PATH,
and run **aws configure** to set up your secret keys and default region.

**makeflow_ec2_estimate** simulate behavior of **makeflow** on **aws** of target workflows, estimating total time of workflow and associated cost. Makefile needs to be labeled with walltime, CPU and memory usage for parsing.

Time and Cost of Three approaches are estimated,
- **Approach 1** where no vms are reused
- **Approach 2** where all vms are reused
- **Approach 3** where suitable(utilized percentage >= 0.5) vms are reused

A config file generated by **makeflow_ec2_setup** could be specified for a more accurate estimation.

Once the cost/workflow execution duration is estimated, you may run **makeflow**
with the **-T amazon** option and give the name of the created
config file with **--amazon-config**.

## OPTIONS

```
usage: makeflow_ec2_estimate [-h] [-l] [-b TCP_BANDWIDTH] [-m MAX_VM_COUNT]
                            [-t TIME_INTERVAL] [-i IDLE_TIME_LEFT]
                            [-p UTIL_PERCENTAGE] [-V VM_INFO] [-c CONFIG_FILE]
                            [-d]
```

### positional arguments ###
                        makefile.json

### optional arguments ###
-  **-h, --help** Show this help message and exit
-  **-l, --local** Estimate workflow execution locally. Not creating a vm to measure spinup time, shutdown time, network bandwidth etc
-  **-b <TCP_BANDWIDTH>, --tcp_bandwidth <TCP_BANDWIDTH>** Set the tcp bandwidth for file transfer speed (default is 10 Mbytes/sec)
-  **-m <MAX_VM_COUNT>, --max_vm_count <MAX_VM_COUNT>** Set the maximum vm count (default is 20 vms)
-  **-t <TIME_INTERVAL>, --time_interval <TIME_INTERVAL>** Set the time interval for vm status update cycle (default is 60s)
-  **-i <IDLE_TIME_LEFT>, --idle_time_left <IDLE_TIME_LEFT>** Set the amount of time idle (default is 30s)
-  **-p <UTIL_PERCENTAGE>, --util_percentage <UTIL_PERCENTAGE>** Set the percentage for a vm to be considered propertly utilized (0 ~ 1.0, default is .5)
-  **-V <VM_INFO>, --vm_info <VM_INFO>** Specifying a json file with avaliable vm name, memory and price info, see script for default dictionary
-  **-c <CONFIG_FILE>, --config_file <CONFIG_FILE>** config file generated by makeflow_ec2_setup, specifying subnet, image-id etc
-  **-d, --debug** Enables debugging and prints debugging logs

## EXAMPLES

```
makeflow_ec2_setup my.config ami-343a694f

makeflow_ec2_estimate makefile.json
makeflow_ec2_estimate makefile.json -c my.config

makeflow -T amazon --amazon-config my.config example.makeflow
makeflow_ec2_cleanup my.config
```

## COPYRIGHT

The Cooperative Computing Tools are Copyright (C) 2005-2020 The University of Notre Dame.  This software is distributed under the GNU General Public License.  See the file COPYING for details.

## SEE ALSO


- [Cooperative Computing Tools Documentation]("../index.html")
- [Makeflow User Manual]("../makeflow.html")
- [makeflow(1)](makeflow.md) [makeflow_monitor(1)](makeflow_monitor.md) [makeflow_analyze(1)](makeflow_analyze.md) [makeflow_viz(1)](makeflow_viz.md) [makeflow_graph_log(1)](makeflow_graph_log.md) [starch(1)](starch.md) [makeflow_ec2_setup(1)](makeflow_ec2_setup.md) [makeflow_ec2_cleanup(1)](makeflow_ec2_cleanup.md)


CCTools 8.0.0 DEVELOPMENT released on
